/* QTagConvert - Editor tags in mp3 files. Designed to convert codepage.
 * Copyright (C) 2007-2008 Skala <skala@users.sourceforge.net>
 * Copyright (C) 2009 Vasiliy Makarov <drmoriarty.0@gmail.com>
 *
 * This is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#define Q2StringToTString(s) TagLib::String(s.toUtf8().data(), TagLib::String::UTF8)
#define TStringToQString(s) QString::fromUtf8(s.toCString(true))
#include "ui_KCmp3Tag.h"
#include <QDirModel>
#include <QList>
#include <qtextcodec.h>
#include <qstring.h>
#include <fileref.h>
#include <tag.h>
#include <tstring.h>
#include <id3v1tag.h>
#include <id3v2tag.h>
#include <mpegfile.h>
//#include <iconv.h>
#include <tbytevector.h>
#include <audioproperties.h>
#include <string>
#include <taglib.h>

using namespace std;

class QStringList;
class QFileInfo;

class mp3Dialog : public QMainWindow, private Ui::mp3Dialog
{
    Q_OBJECT

public:
	QDirModel *dirslist;
public:
    mp3Dialog(QWidget *parent = 0);
private slots:
	void on_homeButton_clicked();
	void on_upButton_clicked();
	void on_comboPath_activated(int index);
	void on_treeDir_clicked(const QModelIndex & index);
	void on_treeDir_activated(const QModelIndex & index);
	void on_v1tov2_clicked();
	void on_v2tov1_clicked();
	void on_ButtonSaveTags_clicked();
	void on_SaveAllFiles_clicked();
	void on_CovertForAll_clicked();

public slots:
	void on_AboutMenu();
	void on_AboutQtMenu();
	void setAction(int);
	void setCodepage(QString);
	void ConvertText(QLineEdit* edit);
	QString Convert(QString text);
	void doTitle1();
	void doArtist1();
	void doAlbum1();
	void doComment1();
	void reloadTitle1();
	void reloadArtist1();
	void reloadAlbum1();
	void reloadComment1();
	void doTitle2();
	void doArtist2();
	void doAlbum2();
	void doComment2();
	void reloadTitle2();
	void reloadArtist2();
	void reloadAlbum2();
	void reloadComment2();
	
protected:
	int action;
	QString codepage;

	void closeEvent(QCloseEvent *event);
	TagLib::MPEG::File *FileMP3Resolver(QString filepath);
	void writtingCodePages(QComboBox *combobox);
	void CharChange (int indexOfCombo, QComboBox *charChanged , QLineEdit *lineedit );
	void setWaitCursor();
	void setArrowCursor();
};

